<?php
class rbac
{
	private $admin=false;
	public  $access;
	public  $public;
	public  $gate;

	public function __construct()
	{
		$this->admin=$_SESSION['administrator']?true:false;
		$this->access=$_SESSION['access'];
	}
	
	public function validate()
	{
		if(empty($this->gate)){
			throw new Exception('RBAC登陆网关没有指定($rbac->gate)');
		}
		
		if($_SESSION['adminislogin']!==true && $this->public!=$_GET['m']){
			
			echo "<meta http-equiv='Refresh' content='0;URL=".$this->gate."'>";
			exit;
		}
		$modelAc  = false;
		$actionAc = false;
		if($this->admin || $this->public==$_GET['m']){
			$modelAc=true;
			$actionAc=true;
		}else{
			foreach($this->access as $k=>$v){
				if($k==$_GET['m']){
					$modelAc=true;
					if(is_array($v)){
						foreach($v as $v2){
							if($v2==$_GET['a']){
								$actionAc=true;
								break;
							}
						}
					}
					break;
				}
			}
		}
		if(!$modelAc || !$actionAc){
            
            if($_GET['json']=='on'){
                $node_=db("admin_node");
                $modelNode=$node_->where("`name`='{$_GET['m']}' and `fnid`='0'")->find();
				$actionNode=$node_->where("`name`='{$_GET['a']}' and `fnid`='{$modelNode['nid']}'")->find();
                $msg= "您没有操作 [{$modelNode['title']}] => [{$actionNode['title']}] 权限！";
                echo json_encode(array("status"=>0,'msg'=>$msg,'info'=>$msg));exit;
            }
			global $config;
			if($config['debug']){
				throw new Exception('您没有权限访问模块: <b style="color:red">'.$_GET['m'].'</b> 操作: <b  style="color:red">'.$_GET['a'].'</b>');
			}else{
				$node_=db("admin_node");
                $modelNode=$node_->where("`name`='{$_GET['m']}' and `fnid`='0'")->find();
				$actionNode=$node_->where("`name`='{$_GET['a']}' and `fnid`='{$modelNode['nid']}'")->find();
				$msg= "您没有操作 [{$modelNode['title']}] => [{$actionNode['title']}] 权限！";
				echo "<script>history.go(-1);alert('{$msg}');</script>";exit;
				unset($db,$modelNode,$actionNode,$msg);
			}
			exit;	
		}
	}
	
	public function loginRbac($uid)
	{
		$_SESSION['adminislogin']=true;
		$groupuser_=db("admin_groupuser");
		$group=$groupuser_->where("`uid`='{$uid}'")->find();
		$access_=db("admin_access as a");
		if($access=$access_->join("admin_node as n on a.nid=n.nid")->where("a.groupid='{$group['groupid']}'")->findAll()){
			foreach($access as $v){
				if($v['level']==1 && $v['fnid']==0){
					$arr[$v['name']]="";
					$arr2[$v['nid']]=$v['name'];
					$arrnid[]=$v['nid'];
				}
			}
			
			foreach($access as $v){
				if(in_array($v['fnid'],$arrnid)){
					$arr[$arr2[$v['fnid']]][]=$v['name'];
				}
			}
			unset($v,$arrnid,$arr2,$access);
		}
        $node_=db("admin_node");
        if($nodeParent=$node_->field("nid,`name`,`title`,`fnid`,`level`")->where("`fnid`=0")->findAll()){
            foreach($nodeParent as $v){
                $_SESSION['node'][$v['nid']]['parent']=$v;
                if($node=$node_->field("nid,`name`,`title`,`fnid`,`level`")->where("`fnid`='{$v['nid']}'")->findAll()){
                    $_SESSION['node'][$v['nid']]['son']=$node;
                }
            }
        }

		$_SESSION['access']=$arr;
	}
	
	function scan($menu)
	{
		$access=$_SESSION['access'];
		if(empty($access)) return false;
		$accessKey=array_keys($access);
		if($_SESSION['administrator']) return $menu;
		$newMenu=array();
		if(!empty($menu)){
			foreach($menu as $k=>$v){
				if(in_array($k,$accessKey)){
					$newMenu[$k]['name']=$v['name'];
					if(!empty($v['s'])){
						foreach($v['s'] as $k2=>$v2){
							if(in_array($k2,$access[$k])){
								$newMenu[$k]['s'][$k2]=$v2;
							}
						}
					}
				}
			}
		}
		return $newMenu;
	}
	
	
}

?>