<?php
/*
#  session入库
#  PDO方式session入库
#  作者：℃冻番茄 qq:7279915
#  web@ye55.com  www.ye55.com (蓝叶工作室)
*/
class session{
    public $lifeTime;
    private $db;
	private $table;

	function __construct()
	{
		if(!$this->db=new PDO(c('dbType').':host='.c('dbHost').';dbname='.c('dbName'), c('dbUser'), c('dbPass'))){
			throw new Exception("数据库连接信息出错！");
		}
		$this->db->exec('SET NAMES utf8'); 
		$this->table=c('sessionTable');
		session_set_save_handler(array(&$this, 'open'),
        array(&$this, 'close'),
        array(&$this, 'read'),
        array(&$this, 'write'),
        array(&$this, 'destroy'),
        array(&$this, 'gc'));
		session_cache_limiter('private, must-revalidate');
		session_start();
	}



    function open($savePath, $sessName)
	{
       $this->lifeTime = get_cfg_var("session.gc_maxlifetime");
       if(!$dbHandle || !$dbSel)return false;
       return true;
    }


    function close()
	{
        $this->gc(ini_get('session.gc_maxlifetime'));
        return ture;
    }


    function read($sessID)
	{
		$sql="SELECT session_data AS d FROM $this->table WHERE session_id = '$sessID' AND session_expires > ".time();
        if(!$res = $this->db->query($sql)){
        	throw new Exception('session数据读取错误  SQL:'.$sql);
        }
        if($row = $res->fetch())return $row['d'];
        return "";
    }


    function write($sessID,$sessData)
	{
        $newExp = time() + $this->lifeTime;
		$sessData=addslashes($sessData);
        $sql="SELECT count(*) FROM $this->table WHERE session_id = '$sessID'";
        if(!$res = $this->db->query($sql)){
        	throw new Exception('session数据写入错误  SQL:'.$sql);
        }
        if($res->fetchColumn())
		{
			//echo "UPDATE $this->table SET session_expires = '$newExp',session_data = '$sessData' WHERE session_id = '$sessID'";
            $aff = $this->db->exec("UPDATE $this->table SET session_expires = '$newExp',session_data = '$sessData' WHERE session_id = '$sessID'");
            if($aff)return true;
        }
        else
		{
			//echo 'insert';
            $aff = $this->db->exec("INSERT INTO $this->table (session_id,session_expires,session_data) VALUES ('$sessID','$newExp','$sessData')");
            if($aff)return true;
        }
        return false;
    }


    function destroy($sessID)
	{
        $aff = $this->db->exec("DELETE FROM $this->table WHERE session_id = '$sessID'");
        if($aff)return true;
        return false;
    }


    function gc($sessMaxLifeTime)
	{
        $aff = $this->db->exec("DELETE FROM $this->table WHERE session_expires < ".time());
        return $aff;
    }
}
$pdo_session = new session();   
?>